CUDNN Frontend API 8.3.0

Public Member Functions | Private Attributes | List of all members
cudnn_frontend::OpaqueBackendPointer Class Reference

`#include <cudnn_backend_base.h>`

Collaboration diagram for cudnn_frontend::OpaqueBackendPointer:

## Public Member Functions
| OpaqueBackendPointer (const OpaqueBackendPointer &)=delete
| Delete the copy constructor to prevent bad copies. More...
OpaqueBackendPointer & | operator= (const OpaqueBackendPointer &)=delete
| OpaqueBackendPointer (OpaqueBackendPointer &&)=default
| OpaqueBackendPointer (cudnnBackendDescriptorType_t type)
| ~OpaqueBackendPointer ()
cudnnBackendDescriptor_t const & | get_backend_descriptor () const
cudnnStatus_t | get_status () const
bool | is_good () const

## Private Attributes
cudnnBackendDescriptor_t | m_desc = nullptr
| Raw void pointer. More...
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| status of creation of the Descriptor More...

## Detailed Description

OpaqueBackendPointer class Holds the raws pointer to backend_descriptor Usage is to wrap this into a smart pointer as it helps to create and destroy the backencpointer

Definition at line 36 of file cudnn_backend_base.h.

## Constructor & Destructor Documentation

## ◆ OpaqueBackendPointer() [1/3]

cudnn_frontend::OpaqueBackendPointer::OpaqueBackendPointer | ( | const OpaqueBackendPointer & |  | ) |
| delete

Delete the copy constructor to prevent bad copies.

## ◆ OpaqueBackendPointer() [2/3]

cudnn_frontend::OpaqueBackendPointer::OpaqueBackendPointer | ( | OpaqueBackendPointer && |  | ) |
| default

## ◆ OpaqueBackendPointer() [3/3]

cudnn_frontend::OpaqueBackendPointer::OpaqueBackendPointer | ( | cudnnBackendDescriptorType_t | type | ) |
| inline

OpaqueBackendPointer constructor. Calls the cudnnBackendCreateDescriptor. Allocates memory according to the type.

Definition at line 50 of file cudnn_backend_base.h.

## ◆ ~OpaqueBackendPointer()

cudnn_frontend::OpaqueBackendPointer::~OpaqueBackendPointer | ( |  | ) |
| inline

OpaqueBackendPointer destructor. Calls the cudnnBackendDestroyDescriptor. Frees memory allocated in the constructor.

Definition at line 55 of file cudnn_backend_base.h.

## Member Function Documentation

## ◆ get_backend_descriptor()

cudnnBackendDescriptor_t const& cudnn_frontend::OpaqueBackendPointer::get_backend_descriptor | ( |  | ) | const
| inline

Accessor. Returns the const reference to raw underlying descriptor. Treat it like the data() function of a smart pointer. Can be freed behind the back.

Definition at line 62 of file cudnn_backend_base.h.

References m_desc.

## ◆ get_status()

cudnnStatus_t cudnn_frontend::OpaqueBackendPointer::get_status | ( |  | ) | const
| inline

Accessor. Queries the status of the descriptor after calling the cudnnCreate.

Definition at line 70 of file cudnn_backend_base.h.

References status.

## ◆ is_good()

bool cudnn_frontend::OpaqueBackendPointer::is_good | ( |  | ) | const
| inline

Accessor. Queries the status of the descriptor returns true if all good.

Definition at line 78 of file cudnn_backend_base.h.

## ◆ operator=()

OpaqueBackendPointer& cudnn_frontend::OpaqueBackendPointer::operator= | ( | const OpaqueBackendPointer & |  | ) |
| delete

## Member Data Documentation

## ◆ m_desc

cudnnBackendDescriptor_t cudnn_frontend::OpaqueBackendPointer::m_desc = nullptr
| private

Raw void pointer.

Definition at line 37 of file cudnn_backend_base.h.

Referenced by get_backend_descriptor().

## ◆ status

cudnnStatus_t cudnn_frontend::OpaqueBackendPointer::status = CUDNN_STATUS_SUCCESS
| private

status of creation of the Descriptor

Definition at line 38 of file cudnn_backend_base.h.

Referenced by get_status(), cudnn_frontend::BackendDescriptor::get_status(), and cudnn_frontend::BackendDescriptor::set_status().

The documentation for this class was generated from the following file:

- cudnn_backend_base.h